#ifndef __AHG_TRACKER_CLIENT_H__
#define __AHG_TRACKER_CLIENT_H__

#include <glib-object.h>

#include <ahoghill/ahg-item.h>

G_BEGIN_DECLS

#define AHG_TYPE_TRACKER_CLIENT                                         \
   (ahg_tracker_client_get_type())
#define AHG_TRACKER_CLIENT(obj)                                         \
   (G_TYPE_CHECK_INSTANCE_CAST ((obj),                                  \
                                AHG_TYPE_TRACKER_CLIENT,                \
                                AhgTrackerClient))
#define AHG_TRACKER_CLIENT_CLASS(klass)                                 \
   (G_TYPE_CHECK_CLASS_CAST ((klass),                                   \
                             AHG_TYPE_TRACKER_CLIENT,                   \
                             AhgTrackerClientClass))
#define IS_AHG_TRACKER_CLIENT(obj)                                      \
   (G_TYPE_CHECK_INSTANCE_TYPE ((obj),                                  \
                                AHG_TYPE_TRACKER_CLIENT))
#define IS_AHG_TRACKER_CLIENT_CLASS(klass)                              \
   (G_TYPE_CHECK_CLASS_TYPE ((klass),                                   \
                             AHG_TYPE_TRACKER_CLIENT))
#define AHG_TRACKER_CLIENT_GET_CLASS(obj)                               \
   (G_TYPE_INSTANCE_GET_CLASS ((obj),                                   \
                               AHG_TYPE_TRACKER_CLIENT,                 \
                               AhgTrackerClientClass))

typedef struct _AhgTrackerClientPrivate AhgTrackerClientPrivate;
typedef struct _AhgTrackerClient      AhgTrackerClient;
typedef struct _AhgTrackerClientClass AhgTrackerClientClass;

typedef void (*AhgTrackerSearchCallback) (AhgTrackerClient *client,
                                          GPtrArray        *results,
                                          GError           *error,
                                          gpointer          userdata);
struct _AhgTrackerClient
{
    GObject parent;

    AhgTrackerClientPrivate *priv;
};

struct _AhgTrackerClientClass
{
    GObjectClass parent_class;
};

GType ahg_tracker_client_get_type (void) G_GNUC_CONST;
AhgItem *ahg_tracker_client_get_item (AhgTrackerClient *client,
                                      const char       *uri);
void ahg_tracker_client_search (AhgTrackerClient         *client,
                                const char               *search_string,
                                AhgTrackerSearchCallback  callback,
                                gpointer                  data);

G_END_DECLS

#endif /* __AHG_TRACKER_CLIENT_H__ */
