#include "ahoghill-play-button.h"

enum {
    PROP_0,
};

struct _AhoghillPlayButtonPrivate {
    int dummy;
};

#define GET_PRIVATE(obj) (G_TYPE_INSTANCE_GET_PRIVATE ((obj), AHOGHILL_TYPE_PLAY_BUTTON, AhoghillPlayButtonPrivate))
G_DEFINE_TYPE (AhoghillPlayButton, ahoghill_play_button, MX_TYPE_BUTTON);

static void
ahoghill_play_button_finalize (GObject *object)
{
    G_OBJECT_CLASS (ahoghill_play_button_parent_class)->finalize (object);
}

static void
ahoghill_play_button_dispose (GObject *object)
{
    G_OBJECT_CLASS (ahoghill_play_button_parent_class)->dispose (object);
}

static void
ahoghill_play_button_set_property (GObject      *object,
                          guint         prop_id,
                          const GValue *value,
                          GParamSpec   *pspec)
{
#if 0
    AhoghillPlayButton *self = (AhoghillPlayButton *) object;

    switch (prop_id) {

    default:
        break;
    }
#endif
}

static void
ahoghill_play_button_get_property (GObject    *object,
                          guint       prop_id,
                          GValue     *value,
                          GParamSpec *pspec)
{
#if 0
    AhoghillPlayButton *self = (AhoghillPlayButton *) object;

    switch (prop_id) {

    default:
        break;
    }
#endif
}

static gboolean
ahoghill_play_button_enter (ClutterActor         *actor,
                            ClutterCrossingEvent *event)
{
    mx_stylable_set_style_pseudo_class (MX_STYLABLE (actor), "hover");
    return FALSE;
}

static gboolean
ahoghill_play_button_leave (ClutterActor         *actor,
                            ClutterCrossingEvent *event)
{
    mx_stylable_set_style_pseudo_class (MX_STYLABLE (actor), NULL);
    return FALSE;
}

static void
ahoghill_play_button_checked (MxButton *button,
                              GParamSpec *pspec,
                              gpointer    data)
{
    gboolean toggled = mx_button_get_checked (button);

    if (toggled) {
        mx_stylable_set_style_class ((MxStylable *) button,
                                        "Toggled");
    } else {
        mx_stylable_set_style_class ((MxStylable *) button, NULL);
    }
}

static void
ahoghill_play_button_class_init (AhoghillPlayButtonClass *klass)
{
    GObjectClass *o_class = (GObjectClass *) klass;
    ClutterActorClass *a_class = (ClutterActorClass *) klass;

    o_class->dispose = ahoghill_play_button_dispose;
    o_class->finalize = ahoghill_play_button_finalize;
    o_class->set_property = ahoghill_play_button_set_property;
    o_class->get_property = ahoghill_play_button_get_property;

    a_class->enter_event = ahoghill_play_button_enter;
    a_class->leave_event = ahoghill_play_button_leave;

    g_type_class_add_private (klass, sizeof (AhoghillPlayButtonPrivate));
}

static void
ahoghill_play_button_init (AhoghillPlayButton *self)
{
    AhoghillPlayButtonPrivate *priv;

    self->priv = GET_PRIVATE (self);
    priv = self->priv;

    mx_button_set_toggle_mode (MX_BUTTON (self), TRUE);
    g_signal_connect (self, "notify::checked",
                      G_CALLBACK (ahoghill_play_button_checked), NULL);
}

void
ahoghill_play_button_set_playing (AhoghillPlayButton *button,
                                  gboolean            playing)
{
    mx_button_set_checked ((MxButton *) button, playing);
    if (playing) {
        mx_stylable_set_style_class ((MxStylable *) button,
                                     "Toggled");
    } else {
        mx_stylable_set_style_class ((MxStylable *) button, NULL);
    }
}
